'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fluxStandardAction = require('flux-standard-action');

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.mapvalues');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var debounceMiddleware = function debounceMiddleware() {
  var config = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  return function () {
    return function (next) {
      var debouncers = (0, _lodash4.default)(config, function (option) {
        if (typeof option === 'number') {
          return (0, _lodash2.default)(next, option);
        }

        var _option$wait = option.wait;
        var wait = _option$wait === undefined ? 0 : _option$wait;

        var options = _objectWithoutProperties(option, ['wait']);

        return (0, _lodash2.default)(next, wait, options);
      });

      return function (action) {
        if (!(0, _fluxStandardAction.isFSA)(action)) {
          return next(action);
        }

        var _action$meta = action.meta;
        var meta = _action$meta === undefined ? {} : _action$meta;

        var debouncer = debouncers[meta.debounce];

        if (debouncer) {
          return debouncer(action);
        }

        return next(action);
      };
    };
  };
};

exports.default = debounceMiddleware;